%define version 1.20
%define release 1mdk
%define name upx

Summary:  The Ultimate Packer for eXecutables
Name:		%{name}
Version:	%{version}
Release:	%{release}
Copyright:	GPL
Group:		Archiving/Compression
Source0:	%{name}-%{version}-src.tar.bz2
URL:		http://wildsau.idv.uni-linz.ac.at/mfx/upx.html
Requires:	glibc ucl
BuildRequires:	glibc-devel, ucl-devel
Prefix:		/usr
BuildRoot:	%{_tmppath}/%{name}-buildroot

%description
UPX is an advanced executable file compressor. UPX will typically
reduce the file size of programs and DLLs by around 50%-70%, thus
reducing disk space, network load times, download times and other
distribution and storage costs.

Programs and libraries compressed by UPX are completely self-contained
and run exactly as before, with no runtime or memory penalty for most
of the supported formats.

UPX supports a number of different executable formats, including
Win95/98/ME/NT/2000 programs and DLLs, DOS programs, and Linux executables.

UPX is rated number one in the well known Archive Comparison Test. Visit
http://web.act.by.net/~act/act-exepack.html


%prep


%setup -n %{name}-%{version}
# this is ugly, but I don't know yet, wether ucl is right (include files in 
# /usr/include), or upx (include files in /usr/include/ucl)
find . -type f -exec perl -pi -e 's/<ucl\/ucl/<ucl/' {} \;

# the Makefile is really not helpful at all, so I'm doing it the bad way
perl -pi -e 's/ -Werror//' src/Makefile

# adding an external hook for our macros
perl -pi -e "s/CC \+= -march=i386 -mcpu=i586/CFLAGS=\\\$\{RPM_OPT_FLAGS\} -fexceptions/" src/Makefile


%build
# building the docs
make -C doc
export UCLDIR=/usr
CFLAGS="$RPM_OPT_FLAGS" make -C src target=linux

     
%install
[ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{prefix}/bin/
install -m 755 src/upx $RPM_BUILD_ROOT%{prefix}/bin/

mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1/
bzip2 -9 -c doc/upx.1 > $RPM_BUILD_ROOT%{_mandir}/man1/upx.1.bz2


%clean
[ -z $RPM_BUILD_ROOT ] || rm -rf $RPM_BUILD_ROOT


%files
%defattr (-,root,root)
%doc BUGS COPYING LICENSE LOADER.TXT NEWS PROJECTS README README.SRC THANKS doc/upx.doc doc/upx.html
%{prefix}/bin/*
%attr(644,root,man) %{_mandir}/man1/*


%changelog
* Mon Jun 18 2001 HA Quc-Vit <viet@mandrakesoft.com> 1.20-1mdk
- Ugly perl -pi -e to include the correct headers from ucl.
- Ugly perl -pi -e to take care of a difficult Makefile.
- Initial packaging.
- TODO see if need NRZ or not
